# Designed December 2009 by C.plassais + Pilou + Jojo2

# Permission to use this software for any purpose and without fee is hereby granted
# Distribution of this software for commercial purpose is forbidden:

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name			:   Eclate_Deplace
# Original Date	:  03 Juil 2009 version 0.0 (thx to TIG, Thomthom)
# Type			:   Plugin
# Description	:   Exploding movements of groups or/and components
# Usage			:   Right Click - Context Menu
# Version 0.3.2
#---------------------------------------------------------------------------------------
# petit plug d'explosion deplacement" de groupes ou de composants

	require 'sketchup.rb'

	def pilou_explose
		myModel = Sketchup.active_model
		myEntities = myModel.entities
		selection = myModel.selection

		if selection.empty?
		    UI.messagebox "请选择组件或群组。"
		end

		myModel.start_operation "模型拆分"
       		group = myModel.active_entities.add_group(selection)
		centre_selec = group.bounds.center
		point_ligne = UI.messagebox "是否保留分解线路和分解基点。", MB_YESNO
       		(point_ligne == 6) ? (myEntities.add_cpoint (centre_selec)) :()

        resultat1 = UI.messagebox "是否保留原模型副件。", MB_YESNO
		if resultat1 == 6
		    group2 = group.copy
		    group2.explode
		end

        selection = group.explode

        cent_selec_x = centre_selec[0].to_i   # determination
		cent_selec_y = centre_selec[1].to_i   # du centre de
		cent_selec_z = centre_selec[2].to_i   # la selection

		prompts = ["基点在世界坐标/基点为反世界坐标 ", "基点X坐标位于世界坐标", "基点Y坐标位于世界坐标", "基点Z坐标位于世界坐标", "X方向拆分距离系数 (≥ 0)", "Y方向拆分距离系数 (≥ 0)", "Z方向拆分距离系数 (≥ 0)", "群组/组件/两者兼得"]
		val_defaut = ["基点在世界坐标", cent_selec_x, cent_selec_y, cent_selec_z, 1.00, 1.00, 1.00, "两者兼得"]
		liste_val = ["基点在世界坐标|基点为反世界坐标", "", "", "", "", "", "" , "群组|组件|两者兼得"]
		results = UI.inputbox prompts, val_defaut, liste_val, "设置"
		return if not results
		decent_pivot, deplac_pivot_x, deplac_pivot_y, deplac_pivot_z, coef_trans_x, coef_trans_y, coef_trans_z, group_ou_comp = results

        # Translation des axes suivant unites
        convertit = []
        convertit[0]= 1.inch
        convertit[1]= 1.feet
        convertit[2]= 1.mm
        convertit[3]= 1.cm
        convertit[4]= 1.m/100
        uniteCourante = myModel.options["UnitsOptions"]["LengthUnit"]

        coef_trans_x = coef_trans_x.to_f * convertit[uniteCourante]
        coef_trans_y = coef_trans_y.to_f * convertit[uniteCourante]
        coef_trans_z = coef_trans_z.to_f * convertit[uniteCourante]

        # Calcul de la distance entre le centre d'origine de la selection et le nouveau
        nouv_pivot_x =  cent_selec_x-deplac_pivot_x
        nouv_pivot_y =  cent_selec_y-deplac_pivot_y
        nouv_pivot_z =  cent_selec_z-deplac_pivot_z
             
        case decent_pivot
             when "基点为反世界坐标"
                  (point_ligne == 6) ? (
                  myEntities.add_cpoint [(cent_selec_x + nouv_pivot_x), (cent_selec_y + nouv_pivot_y), (cent_selec_z + nouv_pivot_z)]
                  myEntities.add_cline [cent_selec_x, cent_selec_y, cent_selec_z],[(cent_selec_x + nouv_pivot_x), (cent_selec_y + nouv_pivot_y), (cent_selec_z + nouv_pivot_z)]) : ()

             when "基点在世界坐标"
                 nouv_pivot_x =  - nouv_pivot_x
    		     nouv_pivot_y =  - nouv_pivot_y
    		     nouv_pivot_z =  - nouv_pivot_z

                 (point_ligne == 6) ? (
    		     myEntities.add_cpoint [deplac_pivot_x,deplac_pivot_y,deplac_pivot_z]
    		     myEntities.add_cline [cent_selec_x, cent_selec_y, cent_selec_z],[deplac_pivot_x, deplac_pivot_y, deplac_pivot_z]) : ()

        end
        
        case group_ou_comp
            when "Group"
                group_ou_comp = comp_ou_group = Sketchup::Group
            when "Component"
                group_ou_comp = comp_ou_group = Sketchup::ComponentInstance
            else
	           group_ou_comp = Sketchup::Group
	           comp_ou_group = Sketchup::ComponentInstance
        end

		selection.each do |e| # debut de la transformation

			next unless (e.is_a? group_ou_comp) or next unless(e.is_a? comp_ou_group)
			centre_objet = e.bounds.center
			centre_objet_x = centre_objet[0].to_i  # Determination
			centre_objet_y = centre_objet[1].to_i  # du centre
			centre_objet_z = centre_objet[2].to_i  # de l'objet

           (centre_objet_x == cent_selec_x) ? (nouv_centobj_x = nouv_pivot_x) : (nouv_centobj_x = ((centre_objet_x-cent_selec_x) * coef_trans_x) + nouv_pivot_x)
           (centre_objet_y == cent_selec_y) ? (nouv_centobj_y = nouv_pivot_y) : (nouv_centobj_y = ((centre_objet_y-cent_selec_y) * coef_trans_y) + nouv_pivot_y)
           (centre_objet_z == cent_selec_z) ? (nouv_centobj_z = nouv_pivot_z) : (nouv_centobj_z = ((centre_objet_z-cent_selec_z) * coef_trans_z) + nouv_pivot_z)

            point_trans = Geom::Point3d.new nouv_centobj_x,nouv_centobj_y,nouv_centobj_z
            t = Geom::Transformation.new point_trans
            e.transform!(t)
            
            (point_ligne == 6) ? (
            nouv_centobj = e.bounds.center
			myEntities.add_cpoint (nouv_centobj)
			myEntities.add_cpoint (centre_objet)
			constline = myEntities.add_cline [centre_objet_x, centre_objet_y, centre_objet_z],nouv_centobj
			constline.stipple = ".") : ()

			myModel.selection.add e

		end
		myModel.commit_operation
	end # pilou_explose

	if( not file_loaded?("Eclate_Deplace.rb") )
        # UI.add_context_menu_handler do |context_menu|
	       # context_menu.add_separator
	       # context_menu.add_item("Eclate_Deplace") { pilou_explose }
        # end
		path = Sketchup.find_support_file("Plugins/Eclate_Deplace")
  EclateDeplace_tb = UI::Toolbar.new("模型拆分插件")
  cmd1 = UI::Command.new("模型拆分插件") { pilou_explose } 
  cmd1.small_icon = File.join(path,"icons/EclateDeplace24.png")
  cmd1.large_icon = File.join(path,"icons/EclateDeplace36.png")
  cmd1.tooltip = "模型拆分插件"
  cmd1.status_bar_text = "模型拆分插件"
  EclateDeplace_tb.add_item(cmd1)
  EclateDeplace_tb.show
		
        file_loaded("Eclate_Deplace.rb")
	end